// 27-01-2014
// rajout possibilite de regler le Gain du CH2 de 1,2,4,5,8,10,16,32
// via la commnde Gx<CR>   x variant de 0  7
// 18F26K22_tests_MC6S22_MAX541_RS_G_140127.hex
// nota : la relecture PIC CH2 plafonne  4.096V (because ref=4.096V!)
// meme si le MAX peut sortir 4.958V
//
//26-01-2014
// Hardware :  voir 18F26K22_MCP6S22_MCP5125_MAX541_TLC271_LM35DZ.DSN
// MCP6S22  AOP 2 Channel      Gain de 10 sur CH0 , Gain de 1 sur CH1
// ADC PIC sur Vref interne de 4096mV
// le maxi  Temperature ne sera plus que de 40,96C pour 1024 points
// MAX541 DAC 16 b
// saisie au clavier consigne MAX541 sous la forme Mxxxxx<CR>
// xxxxx variant de 00000  65535 pour 0mV to 2500mV
// TLC271 AOP rail to rail comme buffer de la sortie du DAC MAX541

//25-01-2014
// Rajout DAC MAX541 16 bits alim +5V out=Vref maxi=2,5V 
// MCP626  6CH
// Test avec LM35DZ  0mV at 0C
// et Gain de 10 pour augmenter la sensibilit  100mV/C
// le maxi sera donc de 50C pour 5,00V et 1024 points
// resolution 0,05C  exploit sur moyenne de 16 mesures.
// nota : +Vref du MCP  2,5V n'agit pas sur la 2em voie ?
// 23-01-2014
// Entrees Ana CH0-1-2 RA0,RA1,RA2 calibrees 0  +5 V
// Test AOP programmable MCP6S22  6 entrees ANALOG en DIP14
// Gain ajustable de 1   32V/V
// ampli rail to rail   avec gain=2 et Entre=2,5V  Vout =4.98V
// CS=1 au repos, passe  Zero pour envoyer une commande
// Cde 0x40 pour acces au Gain 1  32  (Gain=1 pour valeur 0)
// Cde 0x41 pour acces au Chanel 0  7  (Channel 0 pour valeur 0)
// MCP1525  reference de 2,50V  50ppm
// ATTENTION ne pas oublier le 1F sur la sortie Vout , sinon deboires !!!
// LM335 capteur temperature 2731mV at 0C et 10mV/0K
// 22-01-2014
// test MAX141 OK .. avec /Shdn reli au +5 pour utiliser
// Vref externe =VDD au lieu de 2,5V
// car le LM335 sort 2830mV  la temperature ambiante 20C
// option C18 :  -nw=2066 -pa=3 -nw=2054

#include"p18f26k22.h"
#define p18f26k22

#include <stdlib.h>
#include <stdio.h>
#include <adc.h>
//#include <delays.h>
#include "../_common/Delays.h"
#include <string.h>
#include <usart.h>   // pour fonctions UART
#include <ctype.h>
#include <portb.h>
#include <timers.h>
#include <math.h>


// voir Help
//  Topics
//        Pic18
//            config bits settings
//                    choisir PIC18F26K22
#define OSCILLATEUR_INTERNE
//#define WithPLL
#ifdef OSCILLATEUR_INTERNE
   #ifdef WithPLL
    #pragma config FOSC = INTIO67, FCMEN = OFF, PLLCFG=ON            // CONFIG1H
   #else
    #pragma config FOSC = INTIO67, FCMEN = OFF, PLLCFG=OFF            // CONFIG1H    
   #endif   
#else
#pragma config FOSC = HSHP, PLLCFG=OFF, PRICLKEN=ON ,FCMEN=OFF
#endif
#pragma config IESO=OFF,PWRTEN=OFF,BOREN=OFF,WDTEN=OFF,CCP2MX=PORTC1
#pragma config PBADEN=OFF,T3CMX=PORTC0,P2BMX=PORTC0
#pragma config MCLRE=EXTMCLR,STVREN=OFF,LVP=ON,XINST=OFF,DEBUG=OFF
#pragma config CP0 = OFF, CP1 = OFF, CP2 = OFF, CP3 = OFF                    // CONFIG5L
#pragma config CPB = OFF, CPD = OFF                                          // CONFIG5H
#pragma config WRT0 = OFF, WRT1 = OFF, WRT2 = OFF, WRT3 = OFF                // CONFIG6L
#pragma config WRTB = OFF, WRTC = OFF, WRTD = OFF                            // CONFIG6H
#pragma config EBTR0 = OFF, EBTR1 = OFF, EBTR2 = OFF, EBTR3 = OFF            // CONFIG7L
#pragma config EBTRB = OFF                                                   // CONFIG7H
/*

=========== HARDWARE ====================
PIC 18F26k22  microchip  avec Bootoader install en fond de memoire

PortB
B0  21  input <--- Max1241  DOUT  
B1  22  
B2  23  
B3  24
B4  25
B5  26
B6  27
B7  28

PORTA
A0   2
A1   3
A2   4
A3   5 
A4   6  R + Led rouge
A5   7

PORTC
C0   11   output ->   Max1241 SCLK 
C1   12   output ->  Max1241 not CS
C2   13 
C3   14 
C4   15
C5   16 
C6   17  TX  RS232   UART Harware
C7   18  RX  RS232   UART Hardware
====================================================

*/

 #define DEBUG

#ifndef Byte
#define Byte unsigned char
#endif

#define CLS 12
#define BS 8
#define TAB 9
#define CR 13
#define LF 10
#define Bell 7
#define ON 0	// logique inverse avec led tiree au +5V
#define OFF 1

#define Led_Rouge LATAbits.LATA4
#define ON 0	// logique inverse avec led tiree au +5V
#define OFF 1
#define ETEINT 1
#define ALLUME 0

#define OUT_RS232 Drapeaux.Lcd=0;
#define OUT_LCD Drapeaux.Lcd=1;

#define Clock 0.25    // S   at 16Mhz
#define Ualim 5.00
#define ADC_Coeff 4.096/1024.0

// DAC 16 bits SPI ali=+5V  output max==Vref=2.5V  en DIP 8
#define MAX541     
#ifdef MAX541
                                    // VOut pin 1
                                    // VRef pin 3 ... +2,5V
                                    // VDD pin 8
                                    // VSS pin 7
#define MAX541_CS  LATCbits.LATC4    // CS out to pin 4
#define MAX541_SI  LATCbits.LATC1    // SI out to pin 6
#define MAX541_SCK LATCbits.LATC3    // SCK out to pin 5

#endif


#define MCP6S22     // AOP programmable en DIP 8
#ifdef MCP6S22
                                    // VOut pin 1
                                    // EA Ch0  pin 2
                                    // EA Ch1  pin 3
                                    // VSS pin 4
#define MCP6S22_CS  LATCbits.LATC0    // CS out to pin 5
#define MCP6S22_SI  LATCbits.LATC1    // SI out to pin 6
#define MCP6S22_SCK LATCbits.LATC3    // SCK out to pin 7
                                    // VDD pin 14
#endif
/*
Temperatur sensor LM335    2.73V at 0C  10mV/K
1 adjust
2 --> + Vout --- R 2,2K ---<+5V
3 0V

Temperatur sensor LM35DZ   0,00V at 0C
1 -- +5V
2 ------> Vout    10mV/C
3 0V
 
*/


rom const char chaine0[]="...";
rom const char chaine1[]="Oscill interne 16Mhz \r\n";
rom const char chaine2[]="18F26K22_Test_MCP6S22_DAC_MAX541_RS_140127.c\r\n";
rom const char chaine3[]="LM35DZ  0mV @ 0C \r\nDAC MAX541 16bits \r\n";
rom const char chaine4[]="Ref ADC PIC=4,096V \r\n";
rom const char chaine5[]="Erreur de saisie \r\n";
// Attention sous VB6
// verifier l'ordre CRLF et non pas LFCR, sinon on voit 2 car non imprimable
// et pas de changement de ligne
rom char *RS_Str[]={chaine0,chaine1,chaine2,chaine3,chaine4,chaine5};


#pragma romdata EEP_=0xF00000

rom unsigned char EEPROM_data [][32] ={
      //   1234567890123456789012345678901
          "18F26K22_tests_divers.mcp     \r",//0
          "Init PorT Com RS232 19200bds. \r",//20  avec terminateur zero
          "................  <ESC> exit  \r",//40  avec terminateur zero
          "Avec UART HARDWARE........... \r",//60  avec terminateur zero
          "                              \r", //80  sans terminateur
          "paulfjujo@free.fr 23/01/2014 \r", //A0  sans terminateur
          "MPLAB IDE V8.90  C18 v3.45.01\r", //C0  avec terminateur
          "                          \r\n"  //D0 avec terminateur zero
          };
#pragma romdata

#pragma romdata EEP200_=0xF00200
rom unsigned char EEPROM_LCD_Msg [][20] ={
    "Test MCP6S22      \0", // 0
    "18F26K22 C18 16MHz\0" // 20
    };
#pragma romdata

#define SIZE	80		/* taille buffer */		

#pragma udata GrossBank
volatile unsigned char buffer[SIZE];
#pragma udata




/*	Variables globales */

unsigned int count;
                //12345678901234567890
char Texte[SIZE]="18F26K22 MCP6S22 AOP";  // 20 cars

char *txt;
unsigned char Entree[17]="1234567890123456";
Byte CRam1[32];
Byte CRam2[32];

unsigned unsigned char *valtxt;
volatile unsigned char received;
volatile int CptFO,CptFE;           // compteur erreur UART
volatile unsigned char c;
volatile unsigned char *ptlec;		// pointeur de lecture
volatile unsigned char *ptecr;		// pointeur d'ecriture
volatile unsigned int CptCars;
unsigned int SaisieOk;
Byte TableGain2[]={1,2,4,5,8,10,16,32};
Byte Gain2;

unsigned Toto;

Byte receive;
char error;
char EtatCf;
signed char Ve;
unsigned int  NbMes;
Byte Allume_led;
Byte Dummy;
unsigned int i,j,k,l ;
unsigned int ix,jx;
unsigned char s_count = 0;
unsigned int M,M1;
unsigned int EA0;
volatile unsigned char c1;
volatile unsigned int    DataReady1,ErrCom,i1;

unsigned int j1;
unsigned int count;
volatile unsigned int Over;
volatile unsigned long TimeEcoule;  // STATIC  car utilise dans interruption
volatile unsigned long OldTimeEcoule;
unsigned long Maxi;
unsigned long Mini;
unsigned long Cumul;  
float Delta, Moy, Volt ;
float F1,F2;


//unsigned char Drapeaux ;     // 8 flags
struct chbits {   // 8 flags
                 unsigned FrameErr:1;
                 unsigned Over:1;
                 unsigned Elligible:1;
                 unsigned Dummy:1;
                 unsigned Blc:1;
                 unsigned Change:1;
                 unsigned Fill:1;
                 unsigned Lcd:1;
               }Drapeaux ;

 union
{  unsigned char Fanion;
   struct chbits Drapeaux ;
} Flags;

unsigned long Freq;
unsigned char *Decompose;
unsigned int Sd;

// == Functions ====== 
int PutStr_RS(char *s);
void Put_RS(char * untel);
void Raz_Receipt(void);
void CRLF(void);
void Init_Hardware(void);
void Init_Timer1(void);
void configure_PORTC_CCP1 (void );
unsigned char *fltToa (float x, unsigned char *str,char precision);
void aligne8(void);
void Init_ADC(void);
unsigned int Mesure_ADC(int j);
void Cde_MCP6S22(Byte Is,Byte Da);
void Out_MAX541(unsigned int V);

//--- interrupts
void Traite_ISR(void);

// ---- init  interruptions ------------------------
// Serial Interrupt
#pragma code highvector=0x0008
void interrupt_at_high_vector(void)
{
_asm   goto Traite_ISR   _endasm
}
#pragma code

#pragma interrupt Traite_ISR
void Traite_ISR(void)	// reception d'une interruption
{
    //char c;
//==== UART interrupt ===========
if ( (PIE1bits.RC1IE == 1) &&(PIR1bits.RC1IF==1)) // si IT Rx UART
{
    c =Read1USART(); // le lire => RAZ  RCIF
   
     if(RCSTA1bits.FERR==1 )
   {
     RCSTA1bits.SPEN = 0 ;
     Flags.Drapeaux.FrameErr=1;
     CptFE++;
     RCSTA1bits.SPEN= 1 ;
     }
     else
     Flags.Drapeaux.FrameErr=0;

   if (RCSTA1bits.OERR==1)    // voir parag 16.1.26 p273
   {
       RCSTA1bits.CREN = 0 ;
       Flags.Drapeaux.Over=1;
       RCSTA1bits.CREN = 1 ;
       CptFO++;
       }
      else
      Flags.Drapeaux.Over=0;

 // while( Busy1USART()) ; // par scurite
   //if (PORTBbits.RB1==0)
  //  Write1USART(c); // echo
	*ptecr++ = c;
	CptCars++;
	if (ptecr >= buffer+SIZE) ptecr = buffer;
	}
}
         

//--------- RS232 UART HARDWARE --------------


#ifdef MCP6S22

void Cde_MCP6S22(Byte Is,Byte Da)
{
int i,j;
MCP6S22_CS=0; // CS pin 10
MCP6S22_SI=0; // SI pin 11
MCP6S22_SCK=0;// SCK pin 13
Nop();Nop();Nop();Nop();
j=128;
// instruction byte     
for (i=0;i<8;i++)    
{
if ((Is & j)==j)
 MCP6S22_SI=1; 
  else
   MCP6S22_SI=0;  
Nop();Nop();Nop();Nop();
MCP6S22_SCK=1;
Nop();Nop();Nop();Nop();
j=j>>1;
MCP6S22_SCK=0;
}
j=128;
// instruction byte     
for (i=0;i<8;i++)    
{
if ((Da & j)==j)
 MCP6S22_SI=1;  
 else 
 MCP6S22_SI=0;   
Nop();Nop();Nop();Nop();
MCP6S22_SCK=1;
Nop();Nop();Nop();Nop();
j=j>>1;
MCP6S22_SCK=0;
}
Nop();
MCP6S22_CS=1;
}    
#endif




void Tempo(long val)
{
 #ifdef DEBUG
  return;
  #else    
   while(val>0){val--;}
 #endif
}



void Init_UART1(void)
{
// init 19200Bd 
// USART_BRGH_HIGH,32 @ 10MHZ 
// USART_BRGH_HIGH,51 @ 16MHZ 
// USART_BRGH_HIGH,25 @ 8MHZ 
// voir para 18.5 spec sheet DS41159B page 186
#ifdef OSCILLATEUR_INTERNE
  OSCCON=0b01110000;  //HFINTOSC  (16 MHz)
#endif
Open1USART( USART_TX_INT_OFF &
USART_RX_INT_ON &
USART_ASYNCH_MODE &
USART_EIGHT_BIT &
//USART_CONT_RX &
USART_SINGLE_RX &
#ifdef OSCILLATEUR_INTERNE
 // USART_BRGH_HIGH,25    // 16MHz interne BRG16=0  38400bds
#ifdef WithPLL
   USART_BRGH_HIGH,208);  // 16MHzxPLL soit 64Mhz  interne BRG16=0  19200bds
   #else
   USART_BRGH_HIGH,51 ); // 16MHz interne BRG16=0  19200bds sans PLL
#endif   
 #else
  USART_BRGH_HIGH,32 );  // Q=10Mhz 19200bds
#endif
IPR1bits.RC1IP=1;  // high priority for UART
RCONbits.IPEN = 1;     // Enable High interrupt priority model.
PIE1bits.RC1IE = 0;
INTCONbits.PEIE = 0 ; // disable  des IT des priphriques
INTCONbits.GIE = 0 ; //  disable globale des IT
}


int PutStr_RS(char *s)
{
	int n;
	for (n = 0; *s; n++, s++)
	{
       	Put_RS(*s);
     	}
	return n;
}

void Put_RS(char * untel)
{
   	while(Busy1USART());
   	Write1USART(untel);
}

void CRLF()
{
  Put_RS(CR);  Put_RS(LF);
  }

unsigned char Get_RS(void)
	{
	unsigned char c;
	while (ptlec == ptecr);
	c = *ptlec++;
	if (ptlec >= &buffer[SIZE])	ptlec = buffer;
	return (c);
	}




void Write_Word(unsigned int M,char Sign,char Bold)
{
unsigned int i,k,l;
unsigned long M1;
 valtxt=&Entree[0];
 if (Sign>1) return;
 if (Sign==0)
  {       M1=M;
        ultoa(M1,valtxt);
  }
  else itoa(M,valtxt);
 if (Drapeaux.Fill)
 {
  k=strlen(Entree);
  for (i=0;i<k;i++) Entree[4+Sign-i]=Entree[k-i-1];
  for (i=0;i<(5+Sign-k);i++)
  {if (Drapeaux.Blc) Entree[i]='0'; else Entree[i]=' ';}
 }
 Entree[5+Sign]=0;
#ifdef NOKIA 
 if (Drapeaux.Lcd==1) nokia_print_str(valtxt,Bold); else k=PutStr_RS(valtxt);
 #else
 k=PutStr_RS(valtxt);
#endif
}



 unsigned char *fltToa (float x, unsigned char *str,char precision)
{
/* converts a floating point number to an ascii string */
/* x is stored into str, which should be at least 30 chars long */
unsigned char *adpt;
int ie, i, k, ndig;
double y;
adpt=str;
ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
ie = 0;
/* if x negative, write minus and reverse */
if ( x < 0)
  {
  *str++ = '-';
  x = -x;
  }
/* put x in range 1 <= x < 10 */
if (x > 0.0) while (x < 1.0)
  {
  x *= 10.0;		// a la place de =*
  ie--;
  }
while (x >= 10.0)
  {
  x = x/10.0;
  ie++;
 }

// in f format, number of digits is related to size 
 ndig += ie;				// a la place de =+
//round. x is between 1 and 10 and ndig will be printed to
// right of decimal point so rounding is ... 
for (y = i = 1; i < ndig; i++)
  y = y/10.;
x += y/2.;					
if (x >= 10.0) {x = 1.0; ie++;} 
if (ie<0)
  {
   *str++ = '0'; *str++ = '.';
   if (ndig < 0) ie = ie-ndig;
   for (i = -1; i > ie; i--)  *str++ = '0';
  }
for (i=0; i < ndig; i++)
  {
  k = x;
  *str++ = k + '0';
  if (i ==  ie ) *str++ = '.';
  x -= (y=k);	
  x *= 10.0;	
  }
*str = '\0';
return (adpt);
}


void Decompile_byte(Byte un) {
Byte masque;
  masque = 0x80;
  while (masque > 0u )
 {
  if (un & masque)
       Put_RS(49u);  //  '1'
    else
       Put_RS(48u);  //  '0'

    masque =masque >>1;
     }
}

void Octet2Hex(unsigned char number)
{
char high,low;
  // high nibble
  high = ((number & 0xF0) >> 4) + 48; // + '0'
  if (high > '9')
    high =high + 7;
 // low nibble
  low = (number & 0x0F) + 48;          // +'0' low nibble
  if (low > '9')                       // '9'= 57u
    low += 7;                         // > '9'
   Put_RS(high);
   Put_RS(low);
   Put_RS('h');
 }


void Remplis_N_blancs(Byte N)
{int i;
 for (i=0;i<N;i++)
 {
  Put_RS(' ');
 }
}

//---- EEPROM PIC 18F 1Ko bytes  ================
unsigned char EEPROM_Lect(unsigned int adrL) ; // lecture a l'adresse adrL
void EEPROM_Ecr(unsigned int adrE,unsigned char car); // ecrit  a l'adresse adrE
void Save_Msg_To_EEPROM(unsigned char * adrx, unsigned char *ptr1);
void PrintOut_Eeprom_Msg(unsigned int PtrE);  // special for 18F46K22 1024 bytes EEPROM

//------  EEPROM du PIC18Fx6K22 ---------------

unsigned char EEPROM_Lect(unsigned int AdrL) // lecture a l'adresse adr
{  
 
    EEADR =(unsigned char)(AdrL&0x00FF);
    EEADRH =(unsigned char) ((AdrL>>8)&0x0003);   //Bits 2-7 are masked off since EEPROM is only 1KB
	EECON1bits.EEPGD=0;     // 0= adressage EEPROM
	EECON1bits.CFGS=0;      // 0= acces data EEPROM
	EECON1bits.RD=1;        // arme Lecture EEprom
	return(EEDATA);
}

void EEPROM_Ecr(unsigned int AdrE,unsigned char car) // ecrit  a l'adresse adrE
{int dr=0;
    EEADR =AdrE & 0xFF;
    EEADRH = (AdrE>>8)& 0x03;   //Bits 2-7 are masked off since EEPROM is only 1KB
	EEDATA=car;
	EECON1bits.EEPGD=0;
	EECON1bits.WREN=1;            // autorise ecriture EEPROM
	EECON1bits.CFGS =0;
  if(INTCONbits.GIE ==1)
    {
    INTCONbits.GIE =0 ;
    dr=1;
    }
	EECON2=0x55;
	EECON2=0xAA;
	EECON1bits.WR=1;
	while (PIR2bits.EEIF==0);
	PIR2bits.EEIF=0;
	EECON1bits.WREN=0;
	if (dr==1)INTCONbits.GIE =1;
}

void Save_Msg_To_EEPROM(unsigned char * adrx, unsigned char * ptr1)
{
	while (*ptr1) EEPROM_Ecr(adrx++,*ptr1++);
}

void PrintOut_Eeprom_Msg(unsigned int PtrE)
{ unsigned char c;
  do
  {
  if ( PtrE >1023) break;
  c = EEPROM_Lect(PtrE);
  if ( c==0) break;
  Put_RS(c);
  PtrE++;
  }
  while (c!=0)  ;
 Tempo(1000L);
}




void Init_Hardware()
 {
   ANSELB=0;
   PORTB = 0xFF;
   TRISB = 0xFF;
   TRISBbits.TRISB0=1;   	// B0 <- IR input
   TRISBbits.TRISB1=1;   	// B1 input for debug echo reception
   TRISBbits.TRISB2=0;   	// B2 led
   TRISBbits.TRISB3=1;		// B3 not used
   TRISBbits.TRISB4=1;		// B4 not used
   TRISBbits.TRISB5=1;		// B5 not used
   TRISBbits.TRISB6=1;       //  B6 not used
   TRISBbits.TRISB7=1;       //  B7 not used

      // ATTENTION a l'ordre des canaux ANALOGIQUES !!!
   ANSELA=0;
  ANSELAbits.ANSA0=1;    //  analog input on Port A   voir page 154
  ANSELAbits.ANSA1=1;
  ANSELAbits.ANSA2=1;
  TRISA = 0b00001111 ;   // PORTA is RA0,1,2,3= Digital input  RA4,5=Digital output
  
  
  ANSELC=0;
  PORTC = 0xFF;          // set PORTC to $FF
  TRISC = 0b10000100;   
  TRISCbits.TRISC0 = 0;
  TRISCbits.TRISC1 = 0;
  TRISCbits.TRISC2 = 1;  // input   //RC2 as input CCP1 not used
  TRISCbits.TRISC3 = 0;
  TRISCbits.TRISC4 = 0;
  TRISCbits.TRISC5 = 0;
  TRISCbits.TRISC6 = 0;  // TX - Set as Output UART RS232 and Bootloader
  TRISCbits.TRISC7 = 1;  // RX - Set Receive pin for UART RS232 and Bootloader
  SLRCON=0; // standard rate for PORTA,B,C,D,E
  LATC=0;
 }



void aligne8()
{
 j=strlen(CRam1);
 while ( j<8)
 {
   k=fprintf(_H_USART,"x");   // replace "x" by " "
    j++;
  }
 k=fprintf(_H_USART,"%s%c",CRam1,9);
}


//---------------------------------

void Init_ADC()
 {
       //config lecture ADC 10 bits
    
 ADCON0bits.ADON=1;      // ADC enabled chanel 0
 ADCON1bits.TRIGSEL=0 ; // trigger from CCP5
 ADCON2bits.ADFM=1;     // right justified
 ADCON2bits.ACQT2=1;
 ADCON2bits.ACQT1=1;
 ADCON2bits.ACQT0=0;    // 16 TAD
 ADCON2bits.ADCS1=0;   
 ADCON2bits.ADCS2=1;    
 ADCON2bits.ADCS0=0;    // Fosc/32
//A/D VREF+ connected to internal signal, AVDD=+5V
// ADCON1bits.PVCFG1=0; 
// ADCON1bits.PVCFG0=0;
 ///D VREF+ connected to internal signal, FVR BUF2
 ADCON1bits.PVCFG1=1;  
 ADCON1bits.PVCFG0=0;
// -Vref =Gnd 0V
 ADCON1bits.NVCFG1=0;   
 ADCON1bits.NVCFG0=0;
 VREFCON0=0;            // datasheet 21.3 page 344
 VREFCON0bits.FVREN=1;  // enable Fixed volt ref
 VREFCON0bits.FVRS=3;   // 4,096V   ,2=2,048 ,1=1,024 , 0 =0V
 }



 unsigned int Mesure_ADC(int j)  // j=0 pour chanel 0 RA0
{
  unsigned int Mx;
  //ADCON0bits.ADON=1;
  ADCON0=1 + (j<<2);   // ADON=1 et choix de canal
  Delay_mS(1); 
  ConvertADC(); // Start conversion
  while( BusyADC() );
  Mx = ReadADC(); // Read result
 return (Mx);
}

void Init_Timer1()
{
 //--- init timer
 //see PIC18F25K22_46K22_41412E.pdf  12.13 page 172
  T1CONbits.TMR1CS1=0;
  T1CONbits.TMR1CS0=0; // clock source= Fosc/4
  T1CONbits.T1CKPS1=1;
  T1CONbits.T1CKPS0=1; // prescaler =1/8
  T1CONbits.T1SOSCEN=0; // Secondary Oscillator Disabled
  T1CONbits.T1SYNC=0;   // Synchro extern clock input with Fosc  (ignore)
  T1CONbits.T1RD16=1 ;  // Mode 16 bits
  T1CONbits.TMR1ON=0;   // Stop timer1
  //---
  T1GCONbits.TMR1GE=0;  // allways count if TMR1ON=1
  T1GCONbits.T1GTM=0;   // Toogle Gate mode disabled
  T1GCONbits.T1GSS1=0;  // Timer1 gate pin
  T1GCONbits.T1GSS0=0;
  //----
  IPR1bits.TMR1IP=1;      // set hihh priority for Timer1
  RCONbits.IPEN = 1;      // Enable High interrupt priority model.
  WriteTimer1(3035);      // 62500*8*4*0.025 => 50S (@40Mhz)
  PIR1bits.TMR1IF=0;      // raz flag interrupt
  INTCONbits.PEIE = 0;    // enable interupt Peripheriques
  T1CONbits.TMR1ON=0;     // desactive Timer1
  PIE1bits.TMR1IE=0;      // Enable Interrupt Timer1
  INTCONbits.GIE = 0;     // active global interrupt
  INTCONbits.GIEL=0;      // active les priorites  (par8 page 79 docu PIC18Fxx8)
}



#ifdef MAX541

void Out_MAX541(unsigned int V)
{
unsigned int i,j;

MAX541_CS=0; // CS pin 4
MAX541_SCK=0;// SCK pin 5
MAX541_SI=0; // SI pin 6
Nop();Nop();Nop();Nop();
j=32768;
// instruction byte     
for (i=0;i<16;i++)    
{

if ((V & j)==j)
MAX541_SI=1; 
  else
   MAX541_SI=0;  
Nop();Nop();
MAX541_SCK=0;
Nop();Nop();Nop();Nop();
MAX541_SCK=1;
Nop();Nop();Nop();Nop();
j=j>>1;
 MAX541_SCK=0;
}
Nop();
 MAX541_CS=1;
}    
#endif


void Raz_Receipt()
{ptecr=buffer;
      ptlec= ptecr;
      CptCars=0;
      buffer[0]=0;
      c=0;
      receive=0;
 }

void main(void)
{
 
#ifdef OSCILLATEUR_INTERNE  
//  the internal oscillator is set to the default frequency of 1 MHz.
// The Internal Oscillator Frequency Select bits  (IRCF<2:0>)
// select the frequency output of the internal oscillator block  
// pour conserver 19200 bauds  16Mhz sinon retombe  1200 bauds
 OSCCON=0x60;         // Select8 MHz internal clock 
 // OSCCONbits.IRCF2=1; //HFINTOSC  (16 MHz)
 // OSCCONbits.IRCF1=1;
 // OSCCONbits.IRCF0=1;
 //OSCCONbits.SCS1=0;
 //OSCCONbits.SC0=0;
  OSCTUNE=0;
  
 #ifdef WithPLL 
    OSCTUNEbits.PLLEN=1;  // 1= avec PLL => 64Mhz ou 40Mhz
    #else
    OSCTUNEbits.PLLEN=0;  // 0 =sans PLL => 16Mhz  ou 10Mhz
   #endif  
#endif   
    
 Init_Hardware() ;
 MCP6S22_CS=1;
 Led_Rouge=0;

// init des pointeurs stockage reception car
 received=0;
 valtxt=&Entree[0];
 txt=&Texte[0];
 ErrCom=0;
 DataReady1=0;
 i1=0;
 buffer[0]=0;
 ptecr=buffer;
 ptlec= ptecr;
 
  Flags.Fanion=0;           // <- init globale des flags a Zero
  Flags.Drapeaux.Fill=1;    // <- init individuelle des flags
  Flags.Drapeaux.Blc=1;
  Flags.Drapeaux.Elligible=0; // inutile mais pour la comprehension
  Flags.Drapeaux.Change=0;
  Flags.Drapeaux.Dummy=0;
  Flags.Drapeaux.FrameErr=0;
  Flags.Drapeaux.Over=0;

  CptFE=0;
  CptFO=0;

 Init_UART1();
 OUT_RS232
  
 Led_Rouge=1;
 Put_RS(CLS);
 Delay_mS(500);
 CptCars=0;
 count=0;
 CRLF();
 
 txt=&Texte[0]; k=PutStr_RS(txt); CRLF();
 strcpypgm2ram(txt,RS_Str[1]); k=PutStr_RS(txt);
 strcpypgm2ram(txt,RS_Str[2]); k=PutStr_RS(txt);
  strcpypgm2ram(txt,RS_Str[3]); k=PutStr_RS(txt);
 strcpypgm2ram(txt,RS_Str[4]); k=PutStr_RS(txt);
 Tempo(1000L) ;
  
 PrintOut_Eeprom_Msg(0);
 PrintOut_Eeprom_Msg(0x20);
 PrintOut_Eeprom_Msg(0x60);
 PrintOut_Eeprom_Msg(0xA0);
 PrintOut_Eeprom_Msg(0xC0);

 CRLF();
 Tempo(10000L) ;
 
 // init sortie DAC  0V
 Sd=0;
 Out_MAX541(Sd);
 
 LATC=0;
 Init_ADC();

 // init AOP
 Cde_MCP6S22(0x40,0); // acces chanel 0 
 Cde_MCP6S22(0x41,0); // acces Gain=1  
 Gain2=0;  // gain=1
 
 Volt=Ualim;
 k=fprintf(_H_USART,"Alim du Montage =5.0 -> %s%c",fltToa(Volt,CRam1,4),9);
 CRLF(); 
 j=0;M=0;
 // LM35DZ
 // 273K= 0C = 0mV  
 // Pente de 10mV/C
 // Gain de 10 via le MCP6S22
 // donc 100mV par C
 // Echelle Entree Anan RA0 du PIC : 1024pts pour 5000mV soit 50C
 // facteur de calibration =50/1024=0,048828125
 
  Toto=46000;
  k=fprintf(_H_USART,"Toto=%05u ou  %05x\r\n",Toto,Toto);
  
// active IT sur reception de car UART 
  RCSTA1bits.CREN= 1 ;
  PIE1bits.RC1IE = 1;   // autorise interrupt on Car Receive RX UART
  INTCONbits.PEIE = 1;  // autorisation des IT des priphriques
  INTCONbits.GIE = 1;   // active global interrupt
  INTCONbits.GIEL=1;
  
  OUT_RS232
  Raz_Receipt();
  Sd=0;
 do
 { 
  // test si modif gain CH2  au format Gx<CR>
  // x toujour  la meme position dans buffer[1]
  if ((CptCars>2) && (c==13)&& (buffer[0]=='G'))
   {
    c=buffer[1];   
    if( isdigit(c) && (c<56) && (c>=48))
     {
      Gain2=c-48;
      TableGain2[Gain2];       // numerique
      k=fprintf(_H_USART,"\r\n Modif CH2 Gain2 = %c soit %02d \r\n ",c,TableGain2[Gain2]);
      Raz_Receipt();
     }
     else
      {   
        strcpypgm2ram(txt,RS_Str[5]); k=PutStr_RS(txt);
        Delay_mS(1000); 
        Raz_Receipt();
     }
      
   }
  // test si saisie consigne DAC MAX  
   if ((CptCars>6) && (c==13)&& (buffer[0]=='M'))
   {
     SaisieOk=0;
     for (i=1;i<6;i++)
     {
       SaisieOk=SaisieOk+isdigit(buffer[i]);
     }
     if(SaisieOk!=5)
     { 
        strcpypgm2ram(txt,RS_Str[5]); k=PutStr_RS(txt);
        Delay_mS(1000);
        Raz_Receipt();
     }
      else
      { 
        buffer[6]=0; //terminateur de string
        Sd=atoi(buffer+1);       // numerique
        Out_MAX541(Sd);
        Volt= (float)(Sd) *2.50/65536.0;
         k=fprintf(_H_USART,"\r\nBuffer= %s Out Max541 %05u soit %s V \r\n ",buffer,Sd,fltToa(Volt,CRam1,3));
        Raz_Receipt();
        
     }
   }
  Cde_MCP6S22(0x41,0); // acces channel 0     
  Cde_MCP6S22(0x40,5); // acces Gain =10  pour LM35DZ !!!

  Delay_mS(200);
  M1=Mesure_ADC(0);  // 0 pour chanel 0 RA0
  M=M+M1;
  Volt= (float)M1 * ADC_Coeff *10.0 ; //0.048828125 si +5V ;
  k=fprintf(_H_USART,"CH0 x10 %05d soit Temp=%s C %c",M1,fltToa(Volt,CRam1,2),9);
 
   Cde_MCP6S22(0x41,1); // acces channel 1
   Cde_MCP6S22(0x40,Gain2); // acces Gain =1   Test OK  Vout=4,98V avec Gain=2 et 2,50V en entree
 
  Delay_mS(200);
  M1=Mesure_ADC(0);  // 0 pour chanel 0 RA0
  Volt= (float)M1 * ADC_Coeff;
  k=fprintf(_H_USART,"CH1 x%02d relit %s V \r\n",TableGain2[Gain2],fltToa(Volt,CRam1,2));

  Delay_mS(200);
  j++;

 if (j>31)
 { 
     //Volt= (float)(M>>5)* 0.048828125; 
     Volt= (float)(M) *ADC_Coeff/3.2;
     k=fprintf(_H_USART,"Sum32= %05d soit %s C",M,fltToa(Volt,CRam1,3));
     CRLF();
     j=0;
    M=0;
    CRLF();
 }    

 }
 while(1);
}

/*


18F26K22 MCP6S22 AOP
Oscill interne 16Mhz 
LM35DZ  0mV @ 0C 
DAC MAX541 16bits 
Ref ADC PIC=4,096V 
18F26K22_tests_divers.mcp     
Init PorT Com RS232 19200bds. 
Avec UART HARDWARE........... 
paulfjujo@free.fr 23/01/2014 
MPLAB IDE V8.90  C18 v3.45.01

Alim du Montage =5.0 -> 5.0000	
Toto=46000 ou  0b3b0
CH0 x10 00539 soit Temp=21.56 C 	CH1 relit 0.00 V 
CH0 x10 00537 soit Temp=21.48 C 	CH1 relit 0.00 V 
CH0 x10 00535 soit Temp=21.40 C 	CH1 relit 0.00 V 
CH0 x10 00537 soit Temp=21.48 C 	CH1 relit 0.00 V 
CH0 x10 00537 soit Temp=21.48 C 	CH1 relit 0.00 V 
CH0 x10 00536 soit Temp=21.44 C 	CH1 relit 0.00 V 
CH0 x10 00537 soit Temp=21.48 C 	CH1 relit 0.00 V 
CH0 x10 00537 soit Temp=21.48 C 	CH1 relit 0.00 V 
CH0 x10 00535 soit Temp=21.40 C 	CH1 relit 0.00 V 
CH0 x10 00538 soit Temp=21.52 C 	CH1 relit 0.00 V 
CH0 x10 00537 soit Temp=21.48 C 	CH1 relit 0.00 V 
CH0 x10 00537 soit Temp=21.48 C 	CH1 relit 0.00 V 
CH0 x10 00535 soit Temp=21.40 C 	CH1 relit 0.00 V 
CH0 x10 00537 soit Temp=21.48 C 	CH1 relit 0.00 V 
CH0 x10 00537 soit Temp=21.48 C 	CH1 relit 0.00 V 
CH0 x10 00535 soit Temp=21.40 C 	CH1 relit 0.00 V 
CH0 x10 00537 soit Temp=21.48 C 	CH1 relit 0.00 V 
CH0 x10 00538 soit Temp=21.52 C 	CH1 relit 0.00 V 
CH0 x10 00535 soit Temp=21.40 C 	CH1 relit 0.00 V 
CH0 x10 00537 soit Temp=21.48 C 	CH1 relit 0.00 V 
CH0 x10 00537 soit Temp=21.48 C 	CH1 relit 0.00 V 
CH0 x10 00539 soit Temp=21.56 C 	CH1 relit 0.00 V 
CH0 x10 00537 soit Temp=21.48 C 	CH1 relit 0.00 V 
CH0 x10 00537 soit Temp=21.48 C 	CH1 relit 0.00 V 

Buffer= M01000 Out Max541 01000 soit 0.038 V 
 CH0 x10 00537 soit Temp=21.48 C 	CH1 relit 0.00 V 
CH0 x10 00539 soit Temp=21.56 C 	CH1 relit 0.02 V 
CH0 x10 00531 soit Temp=21.24 C 	CH1 relit 0.00 V 
CH0 x10 00526 soit Temp=21.04 C 	CH1 relit 0.03 V 
CH0 x10 00549 soit Temp=21.96 C 	CH1 relit 0.02 V 
CH0 x10 00539 soit Temp=21.56 C 	CH1 relit 0.02 V 
CH0 x10 00533 soit Temp=21.32 C 	CH1 relit 0.00 V 
CH0 x10 00534 soit Temp=21.36 C 	CH1 relit 0.05 V 
Sum32= 17171 soit 21.464 C

CH0 x10 00537 soit Temp=21.48 C 	CH1 relit 0.00 V 

Buffer= M32768 Out Max541 32768 soit 1.250 V 
 CH0 x10 00538 soit Temp=21.52 C 	CH1 relit 1.24 V 
CH0 x10 00537 soit Temp=21.48 C 	CH1 relit 1.24 V 
CH0 x10 00537 soit Temp=21.48 C 	CH1 relit 1.24 V 
CH0 x10 00537 soit Temp=21.48 C 	CH1 relit 1.24 V 
CH0 x10 00537 soit Temp=21.48 C 	CH1 relit 1.24 V 
CH0 x10 00537 soit Temp=21.48 C 	CH1 relit 1.24 V 
CH0 x10 00535 soit Temp=21.40 C 	CH1 relit 1.24 V 
CH0 x10 00538 soit Temp=21.52 C 	CH1 relit 1.24 V 
CH0 x10 00537 soit Temp=21.48 C 	CH1 relit 1.24 V 
CH0 x10 00535 soit Temp=21.40 C 	CH1 relit 1.23 V 

Buffer= M65535 Out Max541 65535 soit 2.500 V 
 CH0 x10 00535 soit Temp=21.40 C 	CH1 relit 2.48 V 
CH0 x10 00538 soit Temp=21.52 C 	CH1 relit 2.48 V 
CH0 x10 00535 soit Temp=21.40 C 	CH1 relit 2.47 V 
CH0 x10 00538 soit Temp=21.52 C 	CH1 relit 2.48 V 
CH0 x10 00537 soit Temp=21.48 C 	CH1 relit 2.48 V 
CH0 x10 00537 soit Temp=21.48 C 	CH1 relit 2.48 V 
CH0 x10 00537 soit Temp=21.48 C 	CH1 relit 2.47 V 
CH0 x10 00537 soit Temp=21.48 C 	CH1 relit 2.48 V 
CH0 x10 00537 soit Temp=21.48 C 	CH1 relit 2.48 V 




----------------------------------------------------------------------
Release build of project `C:\_C18\_MesProjets_C18\_18F26K22\18F26K22_tests_MC6S2x_MAX541.mcp' started.
Language tool versions: MPASMWIN.exe v5.47, mplink.exe v4.45, mcc18.exe v3.44, mplib.exe v4.45
Sun Jan 26 17:06:46 2014
----------------------------------------------------------------------
Clean: Deleting intermediary and output files.
Clean: Done.
Executing: "C:\Program Files\Microchip\mplabc18\bin\mcc18.exe" -p=18F26K22 /i"C:\Program Files\Microchip\mplabc18\h" "C:\_C18\_MesProjets_C18\_common\Delays.c" -fo="C:\_C18\tmp\Delays.o" -Ou- -Ot- -Ob- -Op- -Or- -Od- -Opa-  -nw=2066 -pa=3 -nw=2054
Executing: "C:\Program Files\Microchip\mplabc18\bin\mcc18.exe" -p=18F26K22 /i"C:\Program Files\Microchip\mplabc18\h" "18F26K22_Test_MCP6S22_DAC_MAX541_RS_140126.c" -fo="C:\_C18\tmp\18F26K22_Test_MCP6S22_DAC_MAX541_RS_140126.o" -Ou- -Ot- -Ob- -Op- -Or- -Od- -Opa-  -nw=2066 -pa=3 -nw=2054
C:\_C18\_MesProjets_C18\_18F26K22\18F26K22_Test_MCP6S22_DAC_MAX541_RS_140126.c:899:Warning [2058] call of function without prototype
Executing: "C:\Program Files\Microchip\mplabc18\bin\mplink.exe" /p18F26K22 /l"C:\Program Files\Microchip\mplabc18\lib" /k"C:\Program Files\Microchip\mplabc18\bin\LKR" "..\..\tmp\Delays.o" "..\..\tmp\18F26K22_Test_MCP6S22_DAC_MAX541_RS_140126.o" /u_CRUNTIME /w /o"C:\_C18\_MesProjets_C18\_18F26K22\18F26K22_tests_MC6S2x_MAX541.cof"
MPLINK 4.45, Linker
Device Database Version 1.10
Copyright (c) 1998-2011 Microchip Technology Inc.
Errors    : 0

MP2HEX 4.45, COFF to HEX File Converter
Copyright (c) 1998-2011 Microchip Technology Inc.
Errors    : 0

Loaded C:\_C18\_MesProjets_C18\_18F26K22\18F26K22_tests_MC6S2x_MAX541.cof.
----------------------------------------------------------------------
Release build of project `C:\_C18\_MesProjets_C18\_18F26K22\18F26K22_tests_MC6S2x_MAX541.mcp' succeeded.
Language tool versions: MPASMWIN.exe v5.47, mplink.exe v4.45, mcc18.exe v3.44, mplib.exe v4.45
Sun Jan 26 17:06:53 2014
----------------------------------------------------------------------
BUILD SUCCEEDED

*/